program Int_input
  !
  	  
 ! Alter intensity field according to manually-interpreted boundary
 	 
 ! Usage:
 

  use sep
  
  implicit none

  integer :: nt, nx,ny,ix,it,iy,np,ip,p1,p2,p3,m1,m2,m3,b1,b2,b3,xt_rad,radius,iy_box,ix_box,it_box
  real:: dt,dx,dy,t0,x0,y0,max,min,val,dist,hival
  real,  dimension(:,:,:),allocatable               ::input,output,stest
  real,  dimension(:,:),allocatable         ::picks

  write(0,*) 'after inits'
  !! hook up sep parameter input facility
  call sep_init()

  call from_history("n1",nt); call from_history("n2",nx); call from_history("n3",ny);
  call from_history("o1",t0); call from_history("o2",x0); call from_history("o3",y0);
  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dy);
  
  call from_aux("picks","n2",np)


  call to_history( "n1", nt);  call to_history( "n2", nx); call to_history( "n3", ny)
  call to_history( "d1", dt);  call to_history( "d2", dx); call to_history( "d3", dy)
  call to_history( "o1", t0);  call to_history( "o2", x0); call to_history( "o3", y0)
  call to_history("esize",4);

  allocate(input(nt,nx,ny),output(nt,nx,ny),picks(3,np))


  call sep_read(input)
  call sreed("picks",picks,4*3*np)

  call from_param("radius",radius,10)
  

  output=input

   !! Reassign picked values to high-intensity
     do ip=1,np
      p1=(picks(1,ip)-t0)/dt +1
      p2=(picks(2,ip)-x0)/dx +1
      p3=(picks(3,ip)-y0)/dy +1
      m1=min(p1-1,10); m2=min(p2-1,10); m3=min(p3-1,10); b1=min(nt-p1,10); b2=min(nx-p2,10); b3=min(ny-p3,10)
      val=maxval(input(p1-m1:p1+b1,p2-m2:p2+b2,p3-m3:p3+b3))
      hival=1.5*val
      output(p1-2:p1+2,p2-2:p2+2,p3) = hival
      !write(0,*) pick_vals(ip)

      do iy_box=max(1,p3-radius+1),min(ny,p3+radius)
              if (iy_box .ne. p3) then
                 xt_rad = 2*abs(iy_box - p3)
                 do ix_box=max(1,p2-xt_rad+1),min(nx,p2+xt_rad)
                    do it_box=max(1,p1-xt_rad+1),min(nt,p1+xt_rad)
                       dist=sqrt((real(iy_box-p3))**2.+(real(ix_box-p2))**2.+(real(it_box-p1))**2.)
                       if (dist<=radius) then
!write(0,*) 'it/ix/iy,hival',it_box,ix_box,iy_box
                          output(it_box,ix_box,iy_box) = max(input(it_box,ix_box,iy_box) + hival/dist, output(it_box,ix_box,iy_box))
                          !val_count=val_count+1
                          !sum_val=sum_val+abs(data(it_box,ix_box,iy_box))
                       end if
                    end do
                 end do
              end if
       end do
     end do

  call srite("out",output,4*nt*nx*ny)

end program
