program Merge_segments
  !
  	  
 ! Merge regions from a 3D segmentation result into a single region.
 	 
 ! Usage:
 !	< seg-result.H Merge_segments.x picks= sval= > output.H
 !	   picks: file of coordinates of points within desired regions
 !	   sval: (optional) value of merged segment in output

  use sep
  
  implicit none

  integer :: nt, nx,ny,ix,it,iy,np,ip,p1,p2,p3
  real:: dt,dx,dy,t0,x0,y0,max,min,sval
  real,  dimension(:,:,:),allocatable               ::input,output,stest,s_arr
  real,  dimension(:,:),allocatable         ::picks
  real,  dimension(:),allocatable         ::pick_vals
  write(0,*) 'after inits'
  !! hook up sep parameter input facility
  call sep_init()

  call from_history("n1",nt); call from_history("n2",nx); call from_history("n3",ny);
  call from_history("o1",t0); call from_history("o2",x0); call from_history("o3",y0);
  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dy);
  
  call from_aux("picks","n2",np)
  
  call from_param("sval",sval,50.0)   

  write(0,*) 'n1/n2/n3/sval/npicks',nt,nx,ny,sval,np

  call to_history( "n1", nt);  call to_history( "n2", nx); call to_history( "n3", ny)
  call to_history( "d1", dt);  call to_history( "d2", dx); call to_history( "d3", dy)
  call to_history( "o1", t0);  call to_history( "o2", x0); call to_history( "o3", y0)
  call to_history("esize",4);

  allocate(input(nt,nx,ny),output(nt,nx,ny),picks(3,np),pick_vals(np))
  write(0,*) 'after allocations'

  call sep_read(input)
  call sreed("picks",picks,4*3*np)
  


 write(0,*) 'read in data'

 
   !! Find values assigned to picked segments
     do ip=1,np
      p1=(picks(1,ip)-t0)/dt +1
      p2=(picks(2,ip)-x0)/dx +1
      p3=(picks(3,ip)-y0)/dy +1
      pick_vals(ip) = input(p1,p2,p3)
      !write(0,*) pick_vals(ip)
     end do
	
 write(0,*) pick_vals  ! 'Values' of picked salt regions
output=input


 do iy=1,ny
  do ix=1,nx

   do it=1,nt
    do ip=1,np
   
   if (input(it,ix,iy) == pick_vals(ip)) then
       output(it,ix,iy)=sval
   end if
  end do
 end do
end do
end do

  write(0,*) 'about to write out'
  call srite("out",output,4*nt*nx*ny)

end program
