/*

Modified from code copyright (C) 2006 Pedro Felzenszwalb, under the terms of the GNU General Public License as published by
the Free Software Foundation.

Segments a 3D seismic image (SEP format) using the Pairwise Region Comparison 
 method of Felzenszwalb and Huttenlocher (2004).  Uses a region-based segmentation
 criterion; input data should be an attribute (chaos, frequency) that 
 differentiates regions.
 
 Usage:
 < input_attr.H segment.x k min_size max_dist > output.H
 	k: scaling parameter; typically small (~0.001)
 	min_size: minimum output segment size, in pixels
 	max_dist: length (in pixels) of stencil arms when constructing graph
*/

#include <cstdio>
#include <cstdlib>
#include "segment-image_r.h"
extern "C" { 
  #include "sep3d.h"
} 

int main(int argc, char **argv) { 

sep_begin_prog();
initpar(argc, argv);
init_3d();


int n1,n2,n3,min_size,max_dist;
float sigma,k,e1,e2;
float *data;
if (!hetch ("n1","d", &n1))
      n1=40;
if (!hetch ("n2","d", &n2))
      n2=40;
if (!hetch ("n3","d", &n3))
      n2=40;
if (!getch ("sigma","f", &sigma))
      sigma=.5;
if (!getch ("k","f", &k))
      k=30000;
if (!getch ("min_size","d", &min_size))
      min_size=50;

data = (float*)malloc(n1*n2*n3*4);
if (!sreed("in",data,n1*n2*n3*4))
   fprintf(stderr,"Problem reading in");


  k = atof(argv[1]);
  min_size = atoi(argv[2]);
  max_dist = atoi(argv[3]);	
  //e2 = atoi(argv[4]);

fprintf(stderr,"n1 is %d, n2 is %d, n3 is %d, k is %f, min_size is %d \n", n1,n2,n3,k,min_size);
fprintf(stderr,"argc is %d, e1 is %f, e2 is %f \n", argc, e1, e2);

  fprintf(stderr,"processing\n");
  int num_ccs; 
  float *seg = segment_image(data, n1, n2, n3, sigma, k, min_size, max_dist, &num_ccs);


  fprintf(stderr,"got %d components\n", num_ccs);

 if (n1*n2*n3*4!=srite("out",seg,n1*n2*n3*4))
     seperr("Trouble writing out"); 

  
sep_end_prog();
return 0;

}

