% Deforms the snake in a 2D GVF field using scripts available online


data=ewave;  % Set to name of current image

[x0, y0] = snakeinit(data,1);

[x,y] = snakeinterp(x0,y0,3,1);


% See below for description of parameters
alpha = .05;
beta = .2;
gamma = .2;
kappa = .5;

imagesc(data);
hold on

for i=1:5,
    size(x)
       [x,y] = snakedeform(x,y,alpha,beta,gamma,kappa,px,py,25);
       [x,y] = snakeinterp(x,y,2,0.5);
       snakedisp(x,y,'r',3) 
       title(['Deformation in progress,  iter = ' num2str(i*25)])
       pause(0.5);
end

% SNAKEDEFORM  Deform snake in the given external force field
%     [x,y] = snakedeform(x,y,alpha,beta,gamma,kappa,fx,fy,ITER)
%
%     alpha:   elasticity parameter
%     beta:    rigidity parameter
%     gamma:   viscosity parameter
%     kappa:   external force weight
%     fx,fy:   external force field